Index: LMDZ6/branches/Amaury_dev/libf/dyn3d/lmdz_advtrac.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3d/lmdz_advtrac.f90	(revision 5186)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3d/lmdz_advtrac.f90	(revision 5192)
@@ -18,5 +18,4 @@
     USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_DEBUGIO
     USE lmdz_strings, ONLY: int2str
-    USE lmdz_description, ONLY: descript
     USE lmdz_libmath, ONLY: minmax
     USE lmdz_iniprint, ONLY: lunout, prt_level
Index: LMDZ6/branches/Amaury_dev/libf/dyn3d/lmdz_dynetat0.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3d/lmdz_dynetat0.f90	(revision 5186)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3d/lmdz_dynetat0.f90	(revision 5192)
@@ -24,5 +24,4 @@
     USE ener_mod, ONLY: etot0, ptot0, ztot0, stot0, ang0
     USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_INCA, CPPKEY_REPROBUS
-    USE lmdz_description, ONLY: descript
     USE lmdz_iniprint, ONLY: lunout, prt_level
     USE lmdz_comgeom2
Index: LMDZ6/branches/Amaury_dev/libf/dyn3d/lmdz_dynredem.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3d/lmdz_dynredem.f90	(revision 5186)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3d/lmdz_dynredem.f90	(revision 5192)
@@ -25,5 +25,4 @@
     USE temps_mod, ONLY: annee_ref, day_ref, itau_dyn, itaufin, start_time
     USE ener_mod, ONLY: etot0, ptot0, ztot0, stot0, ang0
-    USE lmdz_description, ONLY: descript
     USE lmdz_iniprint, ONLY: lunout, prt_level
     USE lmdz_comgeom2
@@ -174,5 +173,4 @@
             err, modname, fil, msg
     USE temps_mod, ONLY: itau_dyn, itaufin
-    USE lmdz_description, ONLY: descript
     USE lmdz_iniprint, ONLY: lunout, prt_level
     USE lmdz_comgeom
Index: LMDZ6/branches/Amaury_dev/libf/dyn3d/lmdz_leapfrog.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3d/lmdz_leapfrog.f90	(revision 5186)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3d/lmdz_leapfrog.f90	(revision 5192)
@@ -27,5 +27,4 @@
     USE lmdz_strings, ONLY: msg
     USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_PHYS
-    USE lmdz_description, ONLY: descript
     USE lmdz_iniprint, ONLY: lunout, prt_level
     USE lmdz_ssum_scopy, ONLY: scopy, ssum
Index: LMDZ6/branches/Amaury_dev/libf/dyn3d_common/lmdz_writedynav.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3d_common/lmdz_writedynav.f90	(revision 5186)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3d_common/lmdz_writedynav.f90	(revision 5192)
@@ -12,5 +12,4 @@
     USE comconst_mod, ONLY: cpp
     USE temps_mod, ONLY: itau_dyn
-    USE lmdz_description, ONLY: descript
     USE lmdz_iniprint, ONLY: lunout, prt_level
     USE lmdz_comgeom
Index: LMDZ6/branches/Amaury_dev/libf/dyn3d_common/lmdz_writehist.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3d_common/lmdz_writehist.f90	(revision 5186)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3d_common/lmdz_writehist.f90	(revision 5192)
@@ -11,5 +11,4 @@
     USE com_io_dyn_mod, ONLY: histid, histvid, histuid
     USE temps_mod, ONLY: itau_dyn
-    USE lmdz_description, ONLY: descript
     USE lmdz_iniprint, ONLY: lunout, prt_level
     USE lmdz_comgeom
Index: LMDZ6/branches/Amaury_dev/libf/misc/lmdz_description.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/misc/lmdz_description.f90	(revision 5186)
+++ 	(revision )
@@ -1,7 +1,0 @@
-! Replaces description.h
-
-MODULE lmdz_description
-  IMPLICIT NONE; PRIVATE
-  PUBLIC descript
-  CHARACTER (LEN = 120) :: descript
-END MODULE lmdz_description
Index: LMDZ6/branches/Amaury_dev/libf/misc/lmdz_xer.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/misc/lmdz_xer.f90	(revision 5186)
+++ LMDZ6/branches/Amaury_dev/libf/misc/lmdz_xer.f90	(revision 5192)
@@ -1,6 +1,3 @@
 ! Contains "legacy" xer* functions required by some other very old external code
-
-! Amaury (07/24) WTF ??? We have 1000+ lines of code JUST to allow calling xermsg to print some error message !!??
-! Get rid of this 🤢
 
 MODULE lmdz_xer
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/dyn1d/exner_hyb_m.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/dyn1d/exner_hyb_m.F90	(revision 5186)
+++ 	(revision )
@@ -1,1 +1,0 @@
-link ../../dyn3d_common/exner_hyb_m.F90