Index: LMDZ6/branches/cirrus/libf/phylmdiso/isotopes_mod.F90
===================================================================
--- LMDZ6/branches/cirrus/libf/phylmdiso/isotopes_mod.F90	(revision 5202)
+++ LMDZ6/branches/cirrus/libf/phylmdiso/isotopes_mod.F90	(revision 5203)
@@ -161,5 +161,6 @@
    !=== Local variables:
    INTEGER :: ixt
-
+   LOGICAL :: ltnat1
+   CHARACTER(LEN=maxlen) :: modname, sxt
  
    !--- For H2[17]O
@@ -170,10 +171,7 @@
    LOGICAL, PARAMETER ::   ok_nocinsat = .FALSE. ! if T: no sursaturation effect for ice
    LOGICAL, PARAMETER :: Rdefault_smow = .FALSE. ! if T: Rdefault=smow; if F: nul
-   LOGICAL, PARAMETER :: tnat1 = .TRUE. ! If T: all tnats are 1.
 
    !--- For [3]H
    INTEGER :: iessai
-
-   CHARACTER(LEN=maxlen) :: modname, sxt
 
    modname = 'iso_init'
@@ -265,4 +263,5 @@
    IF(ANY(isoName == 'HTO')) &
    CALL get_in('ok_prod_nucl_tritium', ok_prod_nucl_tritium, .FALSE., .FALSE.)
+   CALL get_in('tnateq1', ltnat1, .TRUE.)
 
    ! Ocean composition
@@ -295,9 +294,5 @@
        tkcin1(ixt) = 0.0005016
        tkcin2(ixt) = 0.0014432
-       if (tnat1) then 
-               tnat(ixt)=1 
-       else 
-               tnat(ixt)=0.
-       endif
+       tnat(ixt) = 0.0; IF(ltnat1) tnat(ixt)=1 
        toce(ixt)=4.0E-19 ! rapport T/H = 0.2 TU Dreisigacker and Roether 1978
        tcorr(ixt)=1.
@@ -318,9 +313,6 @@
        tkcin1(ixt) = tkcin1_O18*fac_kcin
        tkcin2(ixt) = tkcin2_O18*fac_kcin
-       if (tnat1) then 
-               tnat(ixt)=1 
-       else 
-               tnat(ixt)=0.004/100. ! O17 représente 0.004% de l'oxygène
-       endif
+       tnat(ixt)=0.004/100. ! O17 représente 0.004% de l'oxygène
+       IF(ltnat1) tnat(ixt)=1 
        toce(ixt)=tnat(ixt)*(1.0+deltaO18_oce/1000.0)**pente_MWL
        tcorr(ixt)=1.0+fac_enrichoce18*pente_MWL ! donné par Amaelle            
@@ -338,9 +330,5 @@
        tkcin1(ixt) = tkcin1_O18
        tkcin2(ixt) = tkcin2_O18
-       if (tnat1) then
-               tnat(ixt)=1 
-       else 
-               tnat(ixt)=2005.2E-6
-       endif
+       tnat(ixt)=2005.2E-6; IF(ltnat1) tnat(ixt)=1 
        toce(ixt)=tnat(ixt)*(1.0+deltaO18_oce/1000.0)
        tcorr(ixt)=1.0+fac_enrichoce18
@@ -362,9 +350,5 @@
        tkcin1(ixt) = tkcin1_O18*fac_kcin
        tkcin2(ixt) = tkcin2_O18*fac_kcin
-       if (tnat1) then 
-               tnat(ixt)=1
-       else
-               tnat(ixt)=155.76E-6
-       endif
+       tnat(ixt)=155.76E-6; IF(ltnat1) tnat(ixt)=1
        toce(ixt)=tnat(ixt)*(1.0+pente_MWL*deltaO18_oce/1000.0)
        tcorr(ixt)=1.0+fac_enrichoce18*pente_MWL          
Index: LMDZ6/branches/cirrus/libf/phylmdiso/isotopes_routines_mod.F90
===================================================================
--- LMDZ6/branches/cirrus/libf/phylmdiso/isotopes_routines_mod.F90	(revision 5202)
+++ LMDZ6/branches/cirrus/libf/phylmdiso/isotopes_routines_mod.F90	(revision 5203)
@@ -16419,6 +16419,6 @@
    USE isotopes_mod,      ONLY: isoName,iso_HDO,iso_eau
    USE phyetat0_get_mod,  ONLY: phyetat0_get, phyetat0_srf
-   USE readTracFiles_mod, ONLY: new2oldH2O
-   USE strings_mod,       ONLY: strIdx, strTail, maxlen, msg, int2str
+   USE infotrac_phy,      ONLY: new2oldH2O
+   USE strings_mod,       ONLY: strIdx, strHead, strTail, maxlen, msg, int2str
 #ifdef ISOVERIF
    USE isotopes_verif_mod
@@ -16459,6 +16459,5 @@
       outiso = isoName(ixt)
       oldIso = strTail(new2oldH2O(outiso), '_')            !--- Remove "H2O_" from "H2O_<iso>[_<tag>]"
-      i = INDEX(outiso, '_', .TRUE.)
-      oldIso2 = outiso(1:i-1)//outiso(i+1:LEN_TRIM(outiso)) ! CR 2023: on ajoute cette possibilité aussi, elle correspond au cas le plus récent.
+      oldIso2= TRIM(strHead(outiso,'_'))//strTail(outiso,'_') ! CR 2023: most recent possibility
 !      write(*,*) 'tmp 16541:'
 !      write(*,*) 'outiso=',outiso
Index: LMDZ6/branches/cirrus/libf/phylmdiso/isotrac_mod.F90
===================================================================
--- LMDZ6/branches/cirrus/libf/phylmdiso/isotrac_mod.F90	(revision 5202)
+++ LMDZ6/branches/cirrus/libf/phylmdiso/isotrac_mod.F90	(revision 5203)
@@ -3,7 +3,6 @@
 
 MODULE isotrac_mod
-  USE infotrac_phy,      ONLY: niso, ntiso, nzone
-  USE readTracFiles_mod, ONLY: delPhase
-  USE isotopes_mod,      ONLY: ridicule, get_in
+  USE infotrac_phy, ONLY: niso, ntiso, nzone, delPhase
+  USE isotopes_mod, ONLY: ridicule, get_in
 
   IMPLICIT NONE
Index: LMDZ6/branches/cirrus/libf/phylmdiso/phyetat0_mod.F90
===================================================================
--- LMDZ6/branches/cirrus/libf/phylmdiso/phyetat0_mod.F90	(revision 5202)
+++ LMDZ6/branches/cirrus/libf/phylmdiso/phyetat0_mod.F90	(revision 5203)
@@ -41,6 +41,6 @@
   USE geometry_mod,     ONLY: longitude_deg, latitude_deg
   USE iostart,          ONLY: close_startphy, get_field, get_var, open_startphy
-  USE infotrac_phy,     ONLY: nqtot, nbtr, type_trac, tracers
-  USE readTracFiles_mod,ONLY: maxlen, new2oldH2O
+  USE infotrac_phy,     ONLY: nqtot, nbtr, type_trac, tracers, new2oldH2O
+  USE strings_mod,      ONLY: maxlen
   USE traclmdz_mod,     ONLY: traclmdz_from_restart
   USE carbon_cycle_mod, ONLY: carbon_cycle_init, carbon_cycle_cpl, carbon_cycle_tr, carbon_cycle_rad, co2_send, RCO2_glo
Index: LMDZ6/branches/cirrus/libf/phylmdiso/physiq_mod.F90
===================================================================
--- LMDZ6/branches/cirrus/libf/phylmdiso/physiq_mod.F90	(revision 5202)
+++ LMDZ6/branches/cirrus/libf/phylmdiso/physiq_mod.F90	(revision 5203)
@@ -39,6 +39,5 @@
     USE ioipsl_getin_p_mod, ONLY : getin_p
     USE indice_sol_mod
-    USE infotrac_phy, ONLY: nqtot, nbtr, nqo, tracers, type_trac,ivap,iliq,isol
-    USE readTracFiles_mod, ONLY: addPhase
+    USE infotrac_phy, ONLY: nqtot, nbtr, nqo, tracers, type_trac,addPhase, ivap, iliq, isol
     USE strings_mod,  ONLY: strIdx
     USE iophy
@@ -1375,4 +1374,7 @@
 !$OMP THREADPRIVATE(SFRWL)
     !albedo SB <<<
+
+    !--Lea Raillard qs_ini 
+    REAL, dimension(klon,klev) :: qs_ini
 
     !--OB variables for mass fixer (hard coded for now)
@@ -5090,5 +5092,5 @@
 
     CALL lscp(klon,klev,phys_tstep,missing_val,paprs,pplay, &
-         t_seri, q_seri,qs_ancien,ptconv,ratqs, &
+         t_seri, q_seri,qs_ini,ptconv,ratqs, &
          d_t_lsc, d_q_lsc, d_ql_lsc, d_qi_lsc, rneb, rneblsvol, & 
          pfraclr, pfracld, cldfraliq, sigma2_icefracturb, mean_icefracturb,  &
@@ -7172,4 +7174,7 @@
        ENDDO
     ENDDO
+    
+    ! Lea Raillard qs_ini for cloud phase param.
+    qs_ini(:,:)=qs_seri(:,:)
 
     ! C Risi: dispatcher les isotopes dans les xt_seri