Index: LMDZ6/branches/Amaury_dev/DefLists/field_def_lmdz.xml
===================================================================
--- LMDZ6/branches/Amaury_dev/DefLists/field_def_lmdz.xml	(revision 5218)
+++ LMDZ6/branches/Amaury_dev/DefLists/field_def_lmdz.xml	(revision 5219)
@@ -1025,4 +1025,5 @@
         <field id="R2SO4"                long_name="H2SO4 mass fraction in aerosol"                        unit="%" />
         <field id="SAD_sulfate"                long_name="SAD WET sulfate aerosols"                        unit="cm2/cm3" />
+        <field id="reff_sulfate"                long_name="Effective	radius of WET sulfate aerosols"              unit="cm" />
         <field id="sulfMMR"                long_name="Sulfate aerosol concentration (dry mass mixing ratio)"                        unit="kg(H2SO4)/kg(air)" />
         <field id="OCS_lifetime"         long_name="OCS lifetime"                                          unit="s" />
Index: LMDZ6/branches/Amaury_dev/DefLists/file_def_histdaystrataer_lmdz.xml
===================================================================
--- LMDZ6/branches/Amaury_dev/DefLists/file_def_histdaystrataer_lmdz.xml	(revision 5218)
+++ LMDZ6/branches/Amaury_dev/DefLists/file_def_histdaystrataer_lmdz.xml	(revision 5219)
@@ -39,4 +39,5 @@
 	<field field_ref="R2SO4" level="1" />
 	<field field_ref="SAD_sulfate" level="1" />
+        <field field_ref="reff_sulfate" level="5" />
 	<field field_ref="sulfMMR" level="1" />
 	<field field_ref="OCS_lifetime" level="10" />
Index: LMDZ6/branches/Amaury_dev/DefLists/file_def_histstrataer_lmdz.xml
===================================================================
--- LMDZ6/branches/Amaury_dev/DefLists/file_def_histstrataer_lmdz.xml	(revision 5218)
+++ LMDZ6/branches/Amaury_dev/DefLists/file_def_histstrataer_lmdz.xml	(revision 5219)
@@ -42,4 +42,5 @@
 	  <field field_ref="R2SO4" level="1" />
 	  <field field_ref="SAD_sulfate" level="1" />
+	  <field field_ref="reff_sulfate" level="1" />
 	  <field field_ref="sulfMMR" level="1" />
 	  <field field_ref="OCS_lifetime" level="1" />
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/StratAer/traccoag_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/StratAer/traccoag_mod.F90	(revision 5218)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/StratAer/traccoag_mod.F90	(revision 5219)
@@ -12,6 +12,5 @@
     USE phys_local_var_mod, ONLY: mdw, R2SO4, DENSO4, f_r_wet, surf_PM25_sulf, &
             budg_emi_ocs, budg_emi_so2, budg_emi_h2so4, budg_emi_part, &
-            R2SO4B, DENSO4B, f_r_wetB, sulfmmr, SAD_sulfate, sulfmmr_mode, nd_mode
-
+            R2SO4B, DENSO4B, f_r_wetB, sulfmmr, SAD_sulfate, sulfmmr_mode, nd_mode, reff_sulfate
     USE dimphy
     USE infotrac_phy, ONLY: nbtr_bin, nbtr_sulgas, nbtr, id_SO2_strat
@@ -83,4 +82,5 @@
     INTEGER :: injdur_sai          ! injection duration for SAI case [days]
     INTEGER :: yr, is_bissext
+    REAL                                   :: samoment2, samoment3! 2nd and 3rd order moments of size distribution
 
     IF (is_mpi_root .AND. flag_verbose_strataer) THEN
@@ -355,8 +355,9 @@
     sulfmmr_mode(:, :, :) = 0.0
     nd_mode(:, :, :) = 0.0
-
+reff_sulfate(:,:)=0.0
     DO i = 1, klon
       DO j = 1, klev
-        DO it = 1, nbtr_bin
+        samoment2=0.0
+           samoment3=0.0DO it = 1, nbtr_bin
           !surf_PM25_sulf(i)=surf_PM25_sulf(i)+tr_seri(i,1,it+nbtr_sulgas)*m_part(i,1,it) &
           !assume that particles consist of ammonium sulfate at the surface (132g/mol)
@@ -381,5 +382,10 @@
             SAD_sulfate(i, j) = SAD_sulfate(i, j) + nd_mode(i, j, it) &     ! [DRY part/m3A (in bin it)]
                     * 4. * RPI * (mdw(it) * f_r_wetB(i, j, it) / 2.)**2. &       ! [WET SA of part it in m2]
-                    * 1.e-2                                              ! conversion from m2/m3 to cm2/cm3A
+                    * 1.e-2                                              ! conversion from m2/m3 to cm2/cm3A!    samoment2 : 2nd order moment of WET sulfate aerosols (m2/m3)
+                 samoment2 = samoment2 + nd_mode(i,j,it) &     ! [DRY part/m3A (in bin it)]
+                      &  *( mdw(it)*f_r_wetB(i,j,it)/2. )**2.                     ! [WET SA of part it in m2]
+!    samoment3 : 3nd order moment of WET sulfate aerosols (cm2/cm3)
+                 samoment3 = samoment3 + nd_mode(i,j,it) &     ! [DRY part/m3A (in bin it)]
+                      &  *( mdw(it)*f_r_wetB(i,j,it)/2. )**3.                     ! [WET SA of part it in m2]
           ELSE
             !     SAD_sulfate: SAD WET sulfate aerosols (cm2/cm3)
@@ -387,9 +393,15 @@
                     * 4. * RPI * (mdw(it) * f_r_wet(i, j) / 2.)**2. &           ! [WET SA of part it in m2]
                     * 1.e-2                                              ! conversion from m2/m3 to cm2/cm3A
-          ENDIF
-        ENDDO
+!    samoment2 : 2nd order moment of WET sulfate aerosols (m2/m3)
+                 samoment2 = samoment2 + nd_mode(i,j,it) &     ! [DRY part/m3A (in bin it)]
+                      &  *( mdw(it)*f_r_wet(i,j)/2. )**2.                          ! [WET SA of part it in m2]
+!    samoment3 : 3nd order moment of WET sulfate aerosols (cm2/cm3)
+                 samoment3 = samoment3 + nd_mode(i,j,it) &     ! [DRY part/m3A (in bin it)]
+                      &  *( mdw(it)*f_r_wet(i,j)/2. )**3.                          ! [WET SA of part it in m2]          ENDIF
+        ENDDO!     reff_sulfate: effective radius of WET sulfate aerosols (cm)
+           reff_sulfate(i,j) = (samoment3 / samoment2) &
+                & *1.e2                                              ! conversion from m to cm
       ENDDO
     ENDDO
-
   END SUBROUTINE traccoag
 
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/phys_local_var_mod.F90	(revision 5218)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/phys_local_var_mod.F90	(revision 5219)
@@ -763,5 +763,8 @@
   REAL, ALLOCATABLE, SAVE, DIMENSION(:, :) :: SAD_sulfate
   !$OMP THREADPRIVATE(SAD_sulfate)
-  !     sulfate MMR in different modes (based on sulfmmr, it must be dry mmr)
+  !     Effective radius of wet surface aerosols (cm)
+      REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: reff_sulfate
+!$OMP THREADPRIVATE(reff_sulfate)
+!     sulfate MMR in different modes (based on sulfmmr, it must be dry mmr)
   REAL, ALLOCATABLE, SAVE, DIMENSION(:, :, :) :: sulfmmr_mode
   !$OMP THREADPRIVATE(sulfmmr_mode)
@@ -1265,4 +1268,5 @@
       ALLOCATE (sulfmmr(klon, klev))
       ALLOCATE (SAD_sulfate(klon, klev))
+      ALLOCATE (reff_sulfate(klon,klev))
       ALLOCATE (sulfmmr_mode(klon, klev, nbtr_bin))
       ALLOCATE (nd_mode(klon, klev, nbtr_bin))
@@ -1638,4 +1642,5 @@
       DEALLOCATE (sulfmmr)
       DEALLOCATE (SAD_sulfate)
+      DEALLOCATE (reff_sulfate)
       DEALLOCATE (sulfmmr_mode)
       DEALLOCATE (nd_mode)
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/phys_output_ctrlout_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 5218)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 5219)
@@ -1452,4 +1452,6 @@
   TYPE(ctrl_out), SAVE :: o_SAD_sulfate = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
     'SAD_sulfate', 'SAD WET sulfate aerosols', 'cm2/cm3', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_reff_sulfate = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
+    'reff_sulfate', 'Effective radius of WET sulfate aerosols', 'cm', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_sulfmmr = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
     'sulfMMR', 'Sulfate aerosol concentration (dry mass mixing ratio)', 'kg(H2SO4)/kg(air)', (/ ('', i=1, 10) /))
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/phys_output_write_mod.F90	(revision 5218)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/phys_output_write_mod.F90	(revision 5219)
@@ -258,5 +258,5 @@
          o_surf_PM25_sulf, o_ext_strat_550, o_tau_strat_550, &
          o_vsed_aer, o_tau_strat_1020, o_ext_strat_1020, o_f_r_wet, &
-         o_SAD_sulfate, o_sulfmmr, o_nd_mode, o_sulfmmr_mode
+         o_SAD_sulfate, o_reff_sulfate, o_sulfmmr, o_nd_mode, o_sulfmmr_mode
 
     USE ice_sursat_mod, ONLY: flight_m, flight_h2o
@@ -415,5 +415,5 @@
          surf_PM25_sulf, tau_strat_550, tausum_strat, &
          vsed_aer, tau_strat_1020, f_r_wet, &
-         SAD_sulfate, sulfmmr, nd_mode, sulfmmr_mode
+         SAD_sulfate, reff_sulfate, sulfmmr, nd_mode, sulfmmr_mode
     USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_STRATAER
 
@@ -1840,4 +1840,5 @@
           CALL histwrite_phy(o_tau_strat_1020, tausum_strat(:,2))
           CALL histwrite_phy(o_SAD_sulfate, SAD_sulfate)
+          CALL histwrite_phy(o_reff_sulfate, reff_sulfate)
           CALL histwrite_phy(o_sulfmmr, sulfmmr)
           ! All BINs fields