Index: /LMDZ6/branches/Amaury_dev/libf/dyn3d/lmdz_dynetat0.f90
===================================================================
--- /LMDZ6/branches/Amaury_dev/libf/dyn3d/lmdz_dynetat0.f90	(revision 5221)
+++ /LMDZ6/branches/Amaury_dev/libf/dyn3d/lmdz_dynetat0.f90	(revision 5222)
@@ -11,8 +11,8 @@
     ! Purpose: Initial state reading.
     !-------------------------------------------------------------------------------
-    USE lmdz_infotrac, ONLY: nqtot, tracers, niso, iqIsoPha, iH2O, isoName
+    USE lmdz_infotrac, ONLY: nqtot, tracers, niso, iqIsoPha, iH2O, isoName, &
+                         new2oldH2O, newHNO3, oldHNO3, getKey
     USE lmdz_strings, ONLY: maxlen, msg, strStack, real2str, int2str
     USE netcdf, ONLY: nf90_open, nf90_nowrite, nf90_inq_varid, nf90_close, nf90_get_var, nf90_noerr
-    USE lmdz_readTracFiles, ONLY: new2oldH2O, newHNO3, oldHNO3, getKey
     USE control_mod, ONLY: planet_type
     USE lmdz_assert_eq, ONLY: assert_eq
@@ -123,5 +123,5 @@
     var = "temps"
     IF(nf90_inq_varid(fID, var, vID)/=nf90_noerr) THEN
-      CALL msg('missing field <temps> ; trying with <Time>', modname)
+      CALL msg('Missing field <temps> ; trying with <Time>', modname)
       var = "Time"
       CALL err(nf90_inq_varid(fID, var, vID), "inq", var)
@@ -155,5 +155,5 @@
         !--------------------------------------------------------------------------------------------------------------------------
       ELSE IF(nf90_inq_varid(fID, oldVar, vID) == nf90_noerr) THEN                         !=== TRY WITH ALTERNATE NAME
-        CALL msg('Tracer <' // TRIM(var) // '> is missing => initialized to <' // TRIM(oldVar) // '>', modname)
+        CALL msg('Missing tracer <' // TRIM(var) // '> => initialized to <' // TRIM(oldVar) // '>', modname)
         CALL err(nf90_get_var(fID, vID, q(:, :, :, iq)), "get", oldVar)
         !--------------------------------------------------------------------------------------------------------------------------
@@ -171,8 +171,8 @@
                     CALL abort_gcm(TRIM(modname), 'missing isotopic parameters', 1)
           endif
-          CALL msg('Tracer <' // TRIM(var) // '> is missing => initialized with a simplified Rayleigh distillation law.', modname)
+          CALL msg('Missing tracer <' // TRIM(var) // '> => initialized with a simplified Rayleigh distillation law.', modname)
           q(:, :, :, iq) = q(:, :, :, iqParent) * tnat * (q(:, :, :, iqParent) / 30.e-3)**(alpha_ideal - 1.)
         ELSE
-          CALL msg('Tracer <' // TRIM(var) // '> is missing => initialized to its parent isotope concentration.', modname)
+          CALL msg('Missing tracer <' // TRIM(var) // '> => initialized to its parent isotope concentration.', modname)
           ! Camille 9 mars 2023: attention!! seuls les tags qui correspondent à
           ! izone=izone_init (définie dans isotrac_mod) sont initialisés comme
@@ -188,5 +188,5 @@
         !--------------------------------------------------------------------------------------------------------------------------
       ELSE                                                                                 !=== MISSING: SET TO 0
-        CALL msg('Tracer <' // TRIM(var) // '> is missing => initialized to zero', modname)
+        CALL msg('Missing tracer <' // TRIM(var) // '> => initialized to zero', modname)
         q(:, :, :, iq) = 0.
         !--------------------------------------------------------------------------------------------------------------------------
Index: /LMDZ6/branches/Amaury_dev/libf/dyn3d/qminimum.F90
===================================================================
--- /LMDZ6/branches/Amaury_dev/libf/dyn3d/qminimum.F90	(revision 5221)
+++ /LMDZ6/branches/Amaury_dev/libf/dyn3d/qminimum.F90	(revision 5222)
@@ -3,7 +3,6 @@
 SUBROUTINE qminimum(q, nqtot, deltap)
 
-  USE lmdz_infotrac, ONLY: niso, ntiso, iqIsoPha, tracers
+  USE lmdz_infotrac, ONLY: niso, ntiso, iqIsoPha, tracers, addPhase
   USE lmdz_strings, ONLY: strIdx
-  USE lmdz_readTracFiles, ONLY: addPhase
   USE lmdz_ssum_scopy, ONLY: ssum
 
Index: /LMDZ6/branches/Amaury_dev/libf/dyn3dmem/dynetat0_loc.f90
===================================================================
--- /LMDZ6/branches/Amaury_dev/libf/dyn3dmem/dynetat0_loc.f90	(revision 5221)
+++ /LMDZ6/branches/Amaury_dev/libf/dyn3dmem/dynetat0_loc.f90	(revision 5222)
@@ -7,9 +7,9 @@
   !-------------------------------------------------------------------------------
   USE parallel_lmdz
-  USE lmdz_infotrac, ONLY: nqtot, tracers, niso, iqIsoPha, iH2O, isoName
+  USE lmdz_infotrac, ONLY: nqtot, tracers, niso, iqIsoPha, iH2O, isoName, &
+                         new2oldH2O, newHNO3, oldHNO3, getKey
   USE lmdz_strings, ONLY: maxlen, msg, strStack, real2str, int2str, strIdx
   USE netcdf, ONLY: nf90_open, nf90_nowrite, nf90_inquire_dimension, nf90_inq_varid, &
           nf90_close, nf90_get_var, nf90_inquire_variable, nf90_noerr
-  USE lmdz_readTracFiles, ONLY: new2oldH2O, newHNO3, oldHNO3, getKey
   USE control_mod, ONLY: planet_type
   USE lmdz_assert_eq, ONLY: assert_eq
@@ -124,5 +124,5 @@
   var = "temps"
   IF(nf90_inq_varid(fID, var, vID)/=nf90_noerr) THEN
-    CALL msg('missing field <temps> ; trying with <Time>', modname)
+    CALL msg('Missing field <temps> ; trying with <Time>', modname)
     var = "Time"
     CALL err(nf90_inq_varid(fID, var, vID), "inq", var)
@@ -175,5 +175,5 @@
       !--------------------------------------------------------------------------------------------------------------------------
     ELSE IF(nf90_inq_varid(fID, oldVar, vID) == nf90_noerr) THEN                         !=== TRY WITH ALTERNATE NAME
-      CALL msg('Tracer <' // TRIM(var) // '> is missing => initialized to <' // TRIM(oldVar) // '>', modname)
+      CALL msg('Missing tracer <'//TRIM(var)//'> => initialized to <' // TRIM(oldVar) // '>', modname)
       CALL get_var2(oldVar, q_glo); q(ijb_u:ije_u, :, iq) = q_glo(ijb_u:ije_u, :)
       !--------------------------------------------------------------------------------------------------------------------------
@@ -191,10 +191,10 @@
                   CALL abort_gcm(TRIM(modname), 'missing isotopic parameters', 1)
         endif
-        CALL msg('Tracer <' // TRIM(var) // '> is missing => initialized with a simplified Rayleigh distillation law.', modname)
+        CALL msg('Missing tracer <'//TRIM(var)//'> => initialized with a simplified Rayleigh distillation law.', modname)
         q(ijb_u:ije_u, :, iq) = q(ijb_u:ije_u, :, iqParent) * tnat * (q(ijb_u:ije_u, :, iqParent) / 30.e-3)**(alpha_ideal - 1.)
         ! Camille 9 mars 2023: point de vigilence: initialisation incohérente
         ! avec celle de xt_ancien dans la physiq.
       ELSE
-        CALL msg('Tracer <' // TRIM(var) // '> is missing => initialized to its parent isotope concentration.', modname)
+        CALL msg('Missing tracer <'//TRIM(var)//'> => initialized to its parent isotope concentration.', modname)
         ! Camille 9 mars 2023: attention!! seuls les tags qui correspondent à
         ! izone=izone_init (définie dans isotrac_mod) sont initialisés comme
@@ -210,5 +210,5 @@
       !--------------------------------------------------------------------------------------------------------------------------
     ELSE                                                                                 !=== MISSING: SET TO 0
-      CALL msg('Tracer <' // TRIM(var) // '> is missing => initialized to zero', modname)
+      CALL msg('Missing tracer <'//TRIM(var)//'> => initialized to zero', modname)
       q(ijb_u:ije_u, :, iq) = 0.
       !--------------------------------------------------------------------------------------------------------------------------
Index: /LMDZ6/branches/Amaury_dev/libf/dyn3dmem/qminimum_loc.f90
===================================================================
--- /LMDZ6/branches/Amaury_dev/libf/dyn3dmem/qminimum_loc.f90	(revision 5221)
+++ /LMDZ6/branches/Amaury_dev/libf/dyn3dmem/qminimum_loc.f90	(revision 5222)
@@ -4,7 +4,6 @@
   USE parallel_lmdz
   USE lmdz_infotrac, ONLY: niso, ntiso, iqIsoPha, tracers, &
-          isoCheck, min_qParent
+          isoCheck, min_qParent, addPhase
   USE lmdz_strings, ONLY: strIdx
-  USE lmdz_readTracFiles, ONLY: addPhase
   USE lmdz_iniprint, ONLY: lunout, prt_level
 